// roads
#include <stdio.h>
#include <stdlib.h>
//#include <math.h>
#include "ai_roads.h"

////////////////////////////////////////
// Globals
////////////////////////////////////////

node_data
   *road_nodes;

int
   duplicate_count = 0,
	road_nodes_loaded;

int
   total_road_node_link_count,
   total_number_of_road_nodes,
   current_route [MAX_ROUTE_LENGTH],
   best_route [MAX_ROUTE_LENGTH];




////////////////////////////////////////////////////////////
// Functions
////////////////////////////////////////////////////////////

int read_road_route_node_data ();

int main(int argc, char ** argv)
{

	read_road_route_node_data();

	return 0;

} // end main


//
// Data format:
//
// Number of nodes
// loop 	{
//				node_id,			4 bytes
//				number_of_links		4 bytes
//				list of links		4 bytes - node	4 bytes - cost
//			}
//

int read_road_route_node_data ()
{

	int
		loop,
		value,
		node_loop,
		link_loop,
		node_count = 0;

	float
		fvalue;

   FILE
      *file_ptr,
	  *out_data_fp;

   int
      number_of_road_nodes;

   node_data
      *new_node;

	if(( file_ptr = fopen("roads.dat","rb"))==NULL){
		printf("cannot open roads.dat\n");
		exit(1);
	}
	else printf("roads.dat opened\n");

	if(( out_data_fp = fopen("road_data_text.log","wb"))==NULL){
		printf("cannot open road_data_text.log\n");
		exit(1);
	}
	else printf("road_data_text.log opened\n");


	duplicate_count = 0;

	//
	// malloc array of number of road_nodes
	//

	fprintf(out_data_fp, "sizeof node_data = %d\n", sizeof(node_data));
	fprintf(out_data_fp, "sizeof link_data = %d\n", sizeof(link_data));
	fprintf(out_data_fp, "sizeof unsigned int = %d\n", sizeof(unsigned int));
	fprintf(out_data_fp, "sizeof unsigned short int = %d\n", sizeof(unsigned short int));
	fprintf(out_data_fp, "sizeof int = %d\n", sizeof(int));
	fprintf(out_data_fp, "sizeof float = %d\n", sizeof(float));




	// read map sizes
	fread (&fvalue, 4, 1, file_ptr);
	fprintf(out_data_fp, "map size 1 = %f\n", fvalue);
	fread (&fvalue, 4, 1, file_ptr);
	fprintf(out_data_fp, "map size 2 = %f\n", fvalue);

	fread (&total_number_of_road_nodes, 4, 1, file_ptr);

	number_of_road_nodes = total_number_of_road_nodes;

	fprintf(out_data_fp, "Number of road nodes = %d\n\n", total_number_of_road_nodes);

	if (number_of_road_nodes == 0)
	{
		fclose (file_ptr);

		printf("number_of_road_nodes == 0\n");

		exit(1);
	}

	road_nodes = (node_data *) malloc (sizeof (node_data) * number_of_road_nodes);

	new_node = road_nodes;

	total_road_node_link_count = 0;

	while (number_of_road_nodes)
	{
		fprintf(out_data_fp, "\n\t NODE %d\n\n", node_count);

		fread (&value, 4, 1, file_ptr); // read
		new_node->node = value;

		fprintf(out_data_fp, "node  %d\n", value);

		fread (&value, 4, 1, file_ptr);
//		new_node->safe_radius = value;

		// override - DL
		new_node->safe_radius = 28;

		fprintf(out_data_fp, "safe_radius  %d\n", new_node->safe_radius);
				
		fread (&value, 4, 1, file_ptr); // read
		new_node->number_of_links = value;

		fprintf(out_data_fp, "number_of_links  %d\n", value);

		new_node->visited = MAX_ROUTE_LENGTH;

		fprintf(out_data_fp, "visited  %d\n", new_node->visited);
	
		new_node->links = (link_data *) malloc (sizeof (link_data) * ((new_node->number_of_links) + 1));

		fprintf(out_data_fp, "cost		node\n\n");

		for (loop = 0; loop < new_node->number_of_links; loop ++)
		{

			fread (&value, 4, 1, file_ptr);
			new_node->links [loop].node = value;

			fread (&value, 4, 1, file_ptr);
			new_node->links [loop].cost = value;

			new_node->links [loop].breaks = 0;

			fprintf(out_data_fp, "%d\t\t%d\n",
				new_node->links [loop].cost,
				new_node->links [loop].node);
		}
	
		number_of_road_nodes --;

		new_node ++;

		node_count ++;

	} // end while

	fclose (file_ptr);
/*	 
	fprintf(out_data_fp, "Number of road nodes = %d\n\n", total_number_of_road_nodes);

	for(node_loop = 0; node_loop < total_number_of_road_nodes; node_loop++){

		fprintf(out_data_fp, "**************************************\n\n");
		fprintf(out_data_fp, "node  %d\n", (int)road_nodes[node_loop].node);
		fprintf(out_data_fp, "safe_radius  %d\n", (int)road_nodes[node_loop].safe_radius);
		fprintf(out_data_fp, "number_of_links  %d\n", (int)road_nodes[node_loop].number_of_links);
		fprintf(out_data_fp, "visited  %d\n", (int)road_nodes[node_loop].visited);
		fprintf(out_data_fp, "side_occupying  %d\n", (int)road_nodes[node_loop].side_occupying);
		fprintf(out_data_fp, "side_aware  %d\n", (int)road_nodes[node_loop].side_aware);
		fprintf(out_data_fp, "side_exploring  %d\n\n", (int)road_nodes[node_loop].side_exploring);
		fprintf(out_data_fp, "cost		node		breaks\n\n");

		for(link_loop = 0; link_loop < road_nodes[node_loop].number_of_links; link_loop++){

				fprintf(out_data_fp, "%d\t\t%d\t\t%d\n",
				road_nodes[node_loop].links[link_loop].cost,
				(int)road_nodes[node_loop].links[link_loop].node,
				(int)road_nodes[node_loop].links[link_loop].breaks);
		} // end for link loop

		fprintf(out_data_fp, "\n\n");
	} // end for node_loop

*/
	fclose (out_data_fp);

	return 0;

} // end read_road_route_node_data





	
	
	
	
	
	
	
	
	
/*	

		// read map sizes
		safe_fread (&fvalue, 4, 1, file_ptr);
		safe_fread (&fvalue, 4, 1, file_ptr);

		safe_fread (&total_number_of_road_nodes, 4, 1, file_ptr); // craig



		loop all nodes


		safe_fread (&value, 4, 1, file_ptr);
		new_node->node = value;

		safe_fread (&value, 4, 1, file_ptr);
//		new_node->safe_radius = value;

		safe_fread (&value, 4, 1, file_ptr);
		new_node->number_of_links = value;

		for (loop = 0; loop < new_node->number_of_links; loop ++)
		{

			safe_fread (&value, 4, 1, file_ptr);
			new_node->links [loop].node = value;

			safe_fread (&value, 4, 1, file_ptr);
			new_node->links [loop].cost = value;
		}
	
	
	///////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////
	if (file_exist (filename))
	{
	
		file_ptr = safe_fopen (filename, "rb");
	
		duplicate_count = 0;
	
		//
		// malloc array of number of road_nodes
		//

		// read map sizes
		fread (&fvalue, 4, 1, file_ptr);
		fread (&fvalue, 4, 1, file_ptr);

		fread (&total_number_of_road_nodes, 4, 1, file_ptr);

		number_of_road_nodes = total_number_of_road_nodes;

		if (number_of_road_nodes == 0)
		{

			fclose (file_ptr);

			return FALSE;
		}

		road_nodes = (node_data *) malloc_heap_mem (sizeof (node_data) * number_of_road_nodes);

		memset (road_nodes, 0, sizeof (node_data) * number_of_road_nodes);

		#if AI_DEBUG
	
		ai_memory_counter ++;
	
		#endif

		new_node = road_nodes;

		total_road_node_link_count = 0;

		while (number_of_road_nodes)
		{

			fread (&value, 4, 1, file_ptr);
			new_node->node = value;

			#if SAFE_RADIUS
				
			fread (&value, 4, 1, file_ptr);
//			new_node->safe_radius = value;

			#endif

			// override - DL
			new_node->safe_radius = 28;
				
			fread (&value, 4, 1, file_ptr);
			new_node->number_of_links = value;

			new_node->visited = MAX_ROUTE_LENGTH;
	
			new_node->links = (link_data *) malloc_heap_mem (sizeof (link_data) * ((new_node->number_of_links) + 1));

			memset (new_node->links, 0, sizeof (link_data) * ((new_node->number_of_links) + 1));
	
			#if AI_DEBUG
		
			ai_memory_counter ++;
		
			#endif

			for (loop = 0; loop < new_node->number_of_links; loop ++)
			{

				fread (&value, 4, 1, file_ptr);
				new_node->links [loop].node = value;

				fread (&value, 4, 1, file_ptr);
				new_node->links [loop].cost = value;

				new_node->links [loop].breaks = 0;
			}
	
			number_of_road_nodes --;

			#if DEBUG_MODULE >= 2
			{

				int
					loop,
					loop2;
	
				//
				// debug check for duplicate link descriptions
				//
	
				for (loop = 0; loop < new_node->number_of_links; loop ++)
				{
	
					for (loop2 = 0; loop2 < new_node->number_of_links; loop2 ++)
					{
	
						if ((loop != loop2) && (new_node->links [loop].node == new_node->links [loop2].node))
						{
	
							debug_log ("ROUTE: CHECK DUPLICATE ROUTE DESCRIPTION BETWEEN %d AND %d", new_node->node, new_node->links [loop].node);
						}
					}
				}
			}
			#endif

			new_node ++;
		}

		fclose (file_ptr);

		//
		// debug check for duplicate link descriptions
		//

		#if 0
		for (loop = 0; loop < total_number_of_road_nodes; loop ++)
		{

			count = 0;

			other_count = 0;

			for (loop2 = 0; loop2 < road_nodes [loop].number_of_links; loop2 ++)
			{

				for (loop3 = 0; loop3 < road_nodes [loop].number_of_links; loop3 ++)
				{

					if ((loop2 != loop3) && (road_nodes [loop].links [loop2].node == road_nodes [loop].links [loop3].node))
					{

						count ++;

						other_count = 0;

						for (loop4 = 0; loop4 < road_nodes [road_nodes [loop].links [loop2].node].number_of_links; loop4 ++)
						{

							if (road_nodes [road_nodes [loop].links [loop2].node].links [loop4].node == road_nodes [loop].node)
							{

								if (road_nodes [road_nodes [loop].links [loop2].node].node != road_nodes [loop].node)
								{

									other_count ++;
								}
							}
						}
					}
				}
			}

			if (count != other_count)
			{

				duplicate_count += 2;

				#if DEBUG_MODULE

				debug_log ("ROUTE: DUPLICATE ROUTE DESCRIPTION IN NODE %d, dup = %d", road_nodes [loop].node, duplicate_count);

				#endif
			}
		}

		#endif

		return TRUE;
	}

	return FALSE;

*/
