// Grand Roads
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "add_scrn_data.h"

////////////////////////////////////////
// Globals
////////////////////////////////////////

/////////////////////////////////////////////////
// *** start of Global Lists
/////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Holds up to 256 roads and up to 512 quads per road
/////////////////////////////////////////////////////////////////////////////

road
	roads[256],
	temp_roads[256];

//bridge
//	bridges[256];



////////////////////////////////////////////////////
// *** end of Global Lists
////////////////////////////////////////////////////

int
	number_of_roads,
	//max_road_poly_points,
	//min_road_poly_points,
	//number_of_bridges,
	global_number_of_appending_points = 0;

int
	appending_points [256][2];  // x = [][0]  z = [][1]

////////////////////////////////////////////
// Original terraform globals
////////////////////////////////////////////

//float	terrain_3d_map_minimum_height,
//		terrain_3d_map_maximum_height;

//double	terrain_3d_map_scaled_height_difference;

/////////////////////////////////////////
// functions
/////////////////////////////////////////

//static int solve_array(double *a,				 /* input array of wide by high */
//		       double *b,				 /* result array of size high */
//		       int wide,				 /* width of array */
//		       int high);				 /* height of array */
//
//simple_point	get_line_intersection(simple_point p1,
//							  simple_point p2,
//							  simple_point p3,
//							  simple_point p4);

void read_in_road_file(void);

//void build_road_quads(void);

//void print_road_quads(void);

//void write_lcov_file(void);

//int read_in_bridge_file(void);

//void modify_road_data_for_bridges(void);

//int is_between(vec3d br_start, vec3d p, vec3d br_end);

void print_road_file(void);

void load_scrn_data (void);

void write_new_road_file (void);

int file_exist (char *filename);

int main(int argc, char ** argv)
{
	read_in_road_file();

	load_scrn_data ();

	write_new_road_file ();

	print_road_file();


	return 0;


} // end main

////////////////////////////////////
////////////////////////////////////
//                                //
//                                //
//                                //
////////////////////////////////////
////////////////////////////////////

// read in Grand.ROAD file
//
// Data Format
//
// 4 bytes - number of roads
// loop number of roads
//    4 bytes width
//    4 bytes color
//    4 bytes number of points for this road
//    loop number of points
//        x global ( Rob Fox uses ints for floats (int/100 = float))
//        z global

void read_in_road_file(){

	FILE
		*road_fp;

	int
		road_loop,
		point_loop,
		width,
		color,
		number_of_points_for_this_road,
		number_of_quads,
		x_int_pos,						// Rob Fox uses ints for floats (int/100 = float)
		z_int_pos,
		return_value;
	
	printf("reading road file\n");

	if(( road_fp = fopen("powerlines.ROAD","rb"))==NULL){
		printf("cannot open powerlines.ROAD\n");
		exit(1);
	}
	else printf("powerlines.ROAD opened\n");

	//////////////////////////////////////////////////////////////////////
	// read in all the road data which is x and z data only in world coords
	//////////////////////////////////////////////////////////////////////

	fread ( &number_of_roads, sizeof ( int ), 1, road_fp );

	//printf("number of roads = %d\n\n", number_of_roads);

	for(road_loop = 0; road_loop < number_of_roads; road_loop++){

		fread ( &width, sizeof ( int ), 1, road_fp );
		fread ( &color, sizeof ( int ), 1, road_fp );
		fread ( &number_of_points_for_this_road, sizeof ( int ), 1, road_fp );

		roads[road_loop].width = width;

		roads[road_loop].color = color;
		
		roads[road_loop].number_of_center_points = number_of_points_for_this_road;

		roads[road_loop].number_of_quads = number_of_points_for_this_road - 1;

		for(point_loop = 0; point_loop < number_of_points_for_this_road; point_loop++){

			fread ( &x_int_pos, sizeof ( int ), 1, road_fp );
			fread ( &z_int_pos, sizeof ( int ), 1, road_fp );

			roads[road_loop].center_points[point_loop].global_x = (double)x_int_pos / 100.0;
			roads[road_loop].center_points[point_loop].global_z = (double)z_int_pos / 100.0;
		}
	}
	
	fclose ( road_fp );

} // end read_in_road_file()

////////////////////////////////////
////////////////////////////////////
//                                //
//                                //
//                                //
////////////////////////////////////
////////////////////////////////////

void print_road_file(void){

	FILE
		*fp;

	int
		road_loop,
		point_loop,
		width,
		color,
		number_of_points_for_this_road,
		number_of_quads,
		x_int_pos,						// Rob Fox uses ints for floats (int/100 = float)
		z_int_pos,
		return_value;

	float
		x_value,
		z_value;
	
	printf("printing road file\n");

	if(( fp = fopen("ROAD_file_points.log","wb"))==NULL){
		printf("cannot open ROAD_file_points.log\n");
		exit(1);
	}
	else printf("ROAD_file_points.log opened\n");

	//////////////////////////////////////////////////////////////////////
	// write to file all the road data which is x and z data only in world coords
	//////////////////////////////////////////////////////////////////////

	fprintf ( fp, "%d powerlines\n\n", number_of_roads );

	//printf("number of roads = %d\n\n", number_of_roads);

	for(road_loop = 0; road_loop < number_of_roads; road_loop++){

		fprintf ( fp, "powerline %d has %d points\n\n", road_loop,
			roads[road_loop].number_of_center_points );

		//fread ( &width, sizeof ( int ), 1, road_fp );
		//fread ( &color, sizeof ( int ), 1, road_fp );
		//fread ( &number_of_points_for_this_road, sizeof ( int ), 1, road_fp );

		//roads[road_loop].width = width;

		//roads[road_loop].color = color;
		
		//roads[road_loop].number_of_center_points = number_of_points_for_this_road;

		//roads[road_loop].number_of_quads = number_of_points_for_this_road - 1;

		number_of_points_for_this_road = roads[road_loop].number_of_center_points;

		for(point_loop = 0; point_loop < number_of_points_for_this_road; point_loop++){

			x_value = (float)roads[road_loop].center_points[point_loop].global_x;

			z_value = (float)roads[road_loop].center_points[point_loop].global_z;

			fprintf ( fp,"  %f   %f \n", x_value, z_value);


			//fread ( &x_int_pos, sizeof ( int ), 1, road_fp );
			//fread ( &z_int_pos, sizeof ( int ), 1, road_fp );

			//roads[road_loop].center_points[point_loop].global_x = (double)x_int_pos / 100.0;
			//roads[road_loop].center_points[point_loop].global_z = (double)z_int_pos / 100.0;
		}

		fprintf(fp, "\n");
	}
	
	fclose ( fp );
} // end print road file

////////////////////////////////////
////////////////////////////////////
//                                //
//                                //
//                                //
////////////////////////////////////
////////////////////////////////////

void load_scrn_data (void){

	
	FILE
		*in_fp;
		//*out_fp;

	int
		x_int,
		z_int,
		y_int,
		sec_x,
		sec_z,
		count = 0,
		file_number = 0,
		point_count = 0;

	float
		x_float,
		z_float;

	char
		ch,
		x_string [16],
		y_string [16],
		z_string [16],
		sec_x_string [8],
		sec_z_string [8],
		filename [64];

	
/*
	if(( out_fp = fopen("points.log","w"))==NULL){
		printf("cannot open points.log\n");
		exit(1);
	}
	else printf("points.log opened\n");
*/
	while( 1 ){

		sprintf(filename, "C:\\Razorworks\\cohokum\\scrnshot\\IMAGE%03d.TXT", file_number); 

		if( file_exist ( filename ) ){

			if(( in_fp = fopen(filename,"r"))==NULL){
				printf("cannot open %s\n", filename);
				exit(1);
			}
			else printf("%s opened\n", filename);

			fseek( in_fp, 66, SEEK_CUR );

			//
			// get the x value string
			//

			count = 0;

			do{

				ch = getc( in_fp );

				x_string[ count ] = ch;

				count ++;

			} while ( ch != '\n');

			x_string[ count ] = NULL;

			//printf("%s\n", x_string);

			//
			// get the y value string
			//

			fseek( in_fp, 16, SEEK_CUR );

			count = 0;

			do{

				ch = getc( in_fp );

				y_string[ count ] = ch;

				count ++;

			} while ( ch != '\n');

			y_string[ count ] = NULL;

			//printf("%s\n", y_string);

			//
			// get the z value string
			//

			fseek( in_fp, 16, SEEK_CUR );

			count = 0;

			do{

				ch = getc( in_fp );

				z_string[ count ] = ch;

				count ++;

			} while ( ch != '\n');

			z_string[ count ] = NULL;

			//printf("%s\n", z_string);

			//
			// get the sec_x_string
			//

			fseek( in_fp, 16, SEEK_CUR );

			count = 0;

			do{

				ch = getc( in_fp );

				sec_x_string[ count ] = ch;

				count ++;

			} while ( ch != '\n');

			sec_x_string[ count ] = NULL;

			//
			// get the sec_z_string
			//

			fseek( in_fp, 16, SEEK_CUR );

			count = 0;

			do{

				ch = getc( in_fp );

				sec_z_string[ count ] = ch;

				count ++;

			} while ( ch != '\n');

			sec_z_string[ count ] = NULL;




			x_int = (int) atof (x_string);

			z_int = (int) atof (z_string);

			y_int = (int) atof (y_string);

			sec_x = (int) atof (sec_x_string);

			sec_z = (int) atof (sec_z_string);

			appending_points [ point_count ][ 0 ] = x_int;

			appending_points [ point_count ][ 1 ] = z_int;

			point_count ++;


			//fprintf(out_fp, "%d - %d  %d ( %d )  %d - %d x %d\n", file_number,
			//	x_int, z_int, 126976 - z_int, y_int, sec_x, sec_z); 



			
			
		} // end if file_exist
		else{

			break;
		}

		fclose ( in_fp );

		file_number ++;
		
	} // end while

	global_number_of_appending_points = point_count;

	//fclose (out_fp);


} // end load scrn data

//////////////////////////
//////////////////////////
//                      //
//                      //
//////////////////////////
//////////////////////////

void write_new_road_file (void){

		FILE
		*road_fp;

	int
		road_loop,
		point_loop,
		width,
		color,
		number_of_points_for_this_road,
		number_of_quads,
		x_int_pos,						// Rob Fox uses ints for floats (int/100 = float)
		z_int_pos,
		return_value,
		local_number_of_roads;
/*	
	printf("writing road file\n");

	if(( road_fp = fopen("Grand.ROAD","wb"))==NULL){
		printf("cannot open Grand.ROAD\n");
		exit(1);
	}
	else printf("Grand.ROAD opened\n");
*/

	printf("powerlines.ROAD file\n");

	if(( road_fp = fopen("powerlines.ROAD","wb"))==NULL){
		printf("cannot open powerlines.ROAD\n");
		exit(1);
	}
	else printf("powerlines.ROAD opened\n");

	//////////////////////////////////////////////////////////////////////
	// write all the road data which is x and z data only in world coords
	//////////////////////////////////////////////////////////////////////

	local_number_of_roads = number_of_roads + 1;

	fwrite ( &local_number_of_roads, sizeof ( int ), 1, road_fp );

	//printf("number of roads = %d\n\n", number_of_roads);

	for(road_loop = 0; road_loop < number_of_roads; road_loop++){

		width = roads[road_loop].width;

		color = roads[road_loop].color;

		number_of_points_for_this_road = roads[road_loop].number_of_center_points;

		fwrite ( &width, sizeof ( int ), 1, road_fp );
		fwrite ( &color, sizeof ( int ), 1, road_fp );
		fwrite ( &number_of_points_for_this_road, sizeof ( int ), 1, road_fp );

		for(point_loop = 0; point_loop < number_of_points_for_this_road; point_loop++){

			x_int_pos = (int) roads[road_loop].center_points[point_loop].global_x * 100.0;

			z_int_pos = (int) roads[road_loop].center_points[point_loop].global_z * 100.0;

			fwrite ( &x_int_pos, sizeof ( int ), 1, road_fp );
			fwrite ( &z_int_pos, sizeof ( int ), 1, road_fp );

		}

	}

	////////////////////////////////////////////////////////////////////
	// add the appending road
	////////////////////////////////////////////////////////////////////

	fwrite ( &width, sizeof ( int ), 1, road_fp );
	fwrite ( &color, sizeof ( int ), 1, road_fp );
	fwrite ( &global_number_of_appending_points, sizeof ( int ), 1, road_fp );

	for(point_loop = 0; point_loop < global_number_of_appending_points; point_loop++){

		x_int_pos = appending_points [ point_loop ][ 0 ] * 100.0;

		z_int_pos = appending_points [ point_loop ][ 1 ] * 100.0;

		fwrite ( &x_int_pos, sizeof ( int ), 1, road_fp );
		fwrite ( &z_int_pos, sizeof ( int ), 1, road_fp );

	}


	fclose ( road_fp );

} // end write new road file

//////////////////////////
//////////////////////////
//                      //
//                      //
//////////////////////////
//////////////////////////

int file_exist (char *filename)
{
	char fn[32];

	FILE
		*file_ptr;

	if (file_ptr = fopen (filename, "r"))
	{

		fclose (file_ptr);

		return TRUE;
	}

	return FALSE;
}

