// roads
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "roads.h"

////////////////////////////////////////
// Globals
////////////////////////////////////////

node_data
   *road_nodes;

int
   duplicate_count = 0,
	road_nodes_loaded;

int
   total_road_node_link_count,
   total_number_of_road_nodes,
   current_route [MAX_ROUTE_LENGTH],
   best_route [MAX_ROUTE_LENGTH];


////////////////////////////////////////////////////////////
// Functions
////////////////////////////////////////////////////////////

int get_distance(int x, int x1, int z, int z1);

int read_road_route_node_data ();



int main(int argc, char ** argv)
{
	FILE			*fp,
					*out_path_fp,
					*out_node_fp;


	int
					contour_map_number_of_road_nodes,
					contour_map_number_of_road_paths,
					x,
					total,
					count;

	int
		px,
		pz,
		p1x,
		p1z;

	int
		distance;
	
	vec3d			*contour_map_road_nodes,
					*contour_map_road_path_positions,
					*current_position;

	contour_path	*contour_map_road_paths;	
	


	///////////////////////////////////////////////////////
	// read in the nodes
	///////////////////////////////////////////////////////

	if(( out_node_fp = fopen("road_node_text.log","wb"))==NULL){
		printf("cannot open road_node_text.log\n");
		exit(1);
	}
	else printf("road_node_text.log opened\n");

	if(( out_path_fp = fopen("road_path_text.log","wb"))==NULL){
		printf("cannot open road_path_text.log\n");
		exit(1);
	}
	else printf("road_path_text.log opened\n");



	if(( fp = fopen("ROADS.NDE","rb"))==NULL){
		printf("cannot open ROADS.NDE\n");
		exit(1);
	}
	else printf("ROADS.NDE opened\n");

	fread ( &contour_map_number_of_road_nodes, sizeof ( int ), 1, fp );

	contour_map_road_nodes = malloc ( sizeof ( vec3d ) * contour_map_number_of_road_nodes );

	fread ( contour_map_road_nodes, sizeof ( vec3d ), contour_map_number_of_road_nodes, fp );

	//
	// print nodes
	//

	fprintf(out_node_fp, "number of nodes = %d\n\n", contour_map_number_of_road_nodes);

	fprintf(out_node_fp, "node  X  Z  Y\n\n");

	for(x = 0; x < contour_map_number_of_road_nodes; x++){

		fprintf(out_node_fp, "%d  %f  %f  %f\n", x, contour_map_road_nodes[x].x,
			contour_map_road_nodes[x].z, contour_map_road_nodes[x].y);
	}
	
	fclose(fp);

	/////////////////////////////////////////////////////////////
	// read in the paths
	/////////////////////////////////////////////////////////////

	if(( fp = fopen("ROADS.WP","rb"))==NULL){
		printf("cannot open ROADS.WP\n");
		exit(1);
	}
	else printf("ROADS.WP opened\n");

	fread ( &contour_map_number_of_road_paths, sizeof ( int ), 1, fp );

	contour_map_road_paths = malloc ( sizeof ( contour_path ) * contour_map_number_of_road_paths );

	//////////////////////////////////////////////////////////////
	// Process the paths
	//////////////////////////////////////////////////////////////

	//printf("size of contour_path struct = %d\nsize of integer = %d\nsize of float = %d\nsize of vec3d = %d\n\n",
	//	sizeof(contour_path),
	//	sizeof(int),
	//	sizeof(float),
	//	sizeof(*contour_map_road_nodes));

	fprintf(out_path_fp, "number of paths = %d\n\n", contour_map_number_of_road_paths); 

	total = 0;

	for ( count = 0; count < contour_map_number_of_road_paths; count++ )
	{

		fread ( &contour_map_road_paths[count].from, sizeof ( int ), 1, fp );
		fread ( &contour_map_road_paths[count].to, sizeof ( int ), 1, fp );
		fread ( &contour_map_road_paths[count].type, sizeof ( int ), 1, fp );
		fread ( &contour_map_road_paths[count].count, sizeof ( int ), 1, fp );

		total += contour_map_road_paths[count].count;

		fseek ( fp, ( contour_map_road_paths[count].count * sizeof ( vec3d ) ), SEEK_CUR );
	}

	fseek ( fp, 4, SEEK_SET );

	contour_map_road_path_positions = malloc ( sizeof ( vec3d ) * total );

	current_position = contour_map_road_path_positions;

	for ( count = 0; count < contour_map_number_of_road_paths; count++ )
	{

		fread ( &contour_map_road_paths[count].from, sizeof ( int ), 1, fp );
		fread ( &contour_map_road_paths[count].to, sizeof ( int ), 1, fp );
		fread ( &contour_map_road_paths[count].type, sizeof ( int ), 1, fp );
		fread ( &contour_map_road_paths[count].count, sizeof ( int ), 1, fp );

 		//contour_map_road_paths[count].from = bound ( contour_map_road_paths[count].from, 0, contour_map_number_of_road_nodes );
		//contour_map_road_paths[count].to = bound ( contour_map_road_paths[count].to, 0, contour_map_number_of_road_nodes );

		contour_map_road_paths[count].points = current_position;

		fread ( current_position, sizeof ( vec3d ), contour_map_road_paths[count].count, fp );

		//
		// print path data and points
		//

		fprintf(out_path_fp, "path %d  from node %d  to node %d  type = %d  count = %d\n\n", count,
			contour_map_road_paths[count].from,
			contour_map_road_paths[count].to,
			contour_map_road_paths[count].type,
			contour_map_road_paths[count].count);

	//	printf("xmin = %f  xmax = %f  zmin = %f  zmax = %f\n", not used it seems
	//		contour_map_road_paths[count].xmin,
	//		contour_map_road_paths[count].xmax,
	//		contour_map_road_paths[count].zmin,
	//		contour_map_road_paths[count].zmax);


		fprintf(out_path_fp, "points  X  Z  Y\n  Distance\n\n");

		for(x = 0; x < contour_map_road_paths[count].count; x++){

			if(x > 0){

				px = (int)current_position[x - 1].x;
				pz = (int)current_position[x - 1].z;
				p1x = (int)current_position[x].x;
				p1z = (int)current_position[x].z;

				distance = get_distance(px, p1x, pz, p1z);

				fprintf(out_path_fp,"\t%d meters\n", distance);

			} // end if

			fprintf(out_path_fp, "%d  %f  %f  %f\n", x, current_position[x].x,
					current_position[x].z, current_position[x].y);

		} // end for

		fprintf(out_path_fp, "\n");

		current_position += contour_map_road_paths[count].count;
	} // end for number of paths

	fclose ( fp );

	read_road_route_node_data ();

	return 0;

} // end main

int get_distance(int x, int x1, int z, int z1){

	int
		d;

	d = (int)sqrt((double)(((x1 - x) * (x1 - x)) + ((z1 - z) * (z1 - z))));

	return d;

} // end get_distance


//
// Data format:
//
// Number of nodes
// loop 	{
//				node_id,			4 bytes
//				number_of_links		4 bytes
//				list of links		4 bytes - node	4 bytes - cost
//			}
//

int read_road_route_node_data ()
{

	int
		loop,
		value,
		node_loop,
		link_loop,
		node_count = 0;

	float
		fvalue;

   FILE
      *file_ptr,
	  *out_data_fp;

   int
      number_of_road_nodes;

   node_data
      *new_node;

	if(( file_ptr = fopen("roads.dat","rb"))==NULL){
		printf("cannot open roads.dat\n");
		exit(1);
	}
	else printf("roads.dat opened\n");

	if(( out_data_fp = fopen("road_data_text.log","wb"))==NULL){
		printf("cannot open road_data_text.log\n");
		exit(1);
	}
	else printf("road_data_text.log opened\n");


	duplicate_count = 0;

	//
	// malloc array of number of road_nodes
	//
/*
	fprintf(out_data_fp, "sizeof node_data = %d\n", sizeof(node_data));
	fprintf(out_data_fp, "sizeof link_data = %d\n", sizeof(link_data));
	fprintf(out_data_fp, "sizeof unsigned int = %d\n", sizeof(unsigned int));
	fprintf(out_data_fp, "sizeof unsigned short int = %d\n", sizeof(unsigned short int));
	fprintf(out_data_fp, "sizeof int = %d\n", sizeof(int));
	fprintf(out_data_fp, "sizeof float = %d\n", sizeof(float));
*/



	// read map sizes
	fread (&fvalue, 4, 1, file_ptr);
	fprintf(out_data_fp, "map size 1 = %f\n", fvalue);
	fread (&fvalue, 4, 1, file_ptr);
	fprintf(out_data_fp, "map size 2 = %f\n", fvalue);

	fread (&total_number_of_road_nodes, 4, 1, file_ptr);

	number_of_road_nodes = total_number_of_road_nodes;

	fprintf(out_data_fp, "Number of road nodes = %d\n\n", total_number_of_road_nodes);

	if (number_of_road_nodes == 0)
	{
		fclose (file_ptr);

		printf("number_of_road_nodes == 0\n");

		exit(1);
	}

	road_nodes = (node_data *) malloc (sizeof (node_data) * number_of_road_nodes);

	new_node = road_nodes;

	total_road_node_link_count = 0;

	while (number_of_road_nodes)
	{
		fprintf(out_data_fp, "\n\t NODE %d\n\n", node_count);

		fread (&value, 4, 1, file_ptr); // read
		new_node->node = value;

		fprintf(out_data_fp, "node  %d\n", value);

		fread (&value, 4, 1, file_ptr);
//		new_node->safe_radius = value;

		// override - DL
		new_node->safe_radius = 28;

		fprintf(out_data_fp, "safe_radius  %d\n", new_node->safe_radius);
				
		fread (&value, 4, 1, file_ptr); // read
		new_node->number_of_links = value;

		fprintf(out_data_fp, "number_of_links  %d\n", value);

		new_node->visited = MAX_ROUTE_LENGTH;

		//fprintf(out_data_fp, "visited  %d\n", new_node->visited);
	
		new_node->links = (link_data *) malloc (sizeof (link_data) * ((new_node->number_of_links) + 1));

		fprintf(out_data_fp, "\ncost		node\n\n");

		for (loop = 0; loop < new_node->number_of_links; loop ++)
		{

			fread (&value, 4, 1, file_ptr);
			new_node->links [loop].node = value;

			fread (&value, 4, 1, file_ptr);
			new_node->links [loop].cost = value;

			new_node->links [loop].breaks = 0;

			fprintf(out_data_fp, "%d\t\t%d\n",
				new_node->links [loop].cost,
				new_node->links [loop].node);
		}
	
		number_of_road_nodes --;

		new_node ++;

		node_count ++;

	} // end while

	fclose (file_ptr);

	fclose (out_data_fp);

	return 0;

} // end read_road_route_node_data


